package com.hai.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class HighOrderPreExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public HighOrderPreExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNull() {
            addCriterion("company_id is null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNotNull() {
            addCriterion("company_id is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdEqualTo(Long value) {
            addCriterion("company_id =", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotEqualTo(Long value) {
            addCriterion("company_id <>", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThan(Long value) {
            addCriterion("company_id >", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThanOrEqualTo(Long value) {
            addCriterion("company_id >=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThan(Long value) {
            addCriterion("company_id <", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThanOrEqualTo(Long value) {
            addCriterion("company_id <=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIn(List<Long> values) {
            addCriterion("company_id in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotIn(List<Long> values) {
            addCriterion("company_id not in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdBetween(Long value1, Long value2) {
            addCriterion("company_id between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotBetween(Long value1, Long value2) {
            addCriterion("company_id not between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andMerchantIdIsNull() {
            addCriterion("merchant_id is null");
            return (Criteria) this;
        }

        public Criteria andMerchantIdIsNotNull() {
            addCriterion("merchant_id is not null");
            return (Criteria) this;
        }

        public Criteria andMerchantIdEqualTo(Long value) {
            addCriterion("merchant_id =", value, "merchantId");
            return (Criteria) this;
        }

        public Criteria andMerchantIdNotEqualTo(Long value) {
            addCriterion("merchant_id <>", value, "merchantId");
            return (Criteria) this;
        }

        public Criteria andMerchantIdGreaterThan(Long value) {
            addCriterion("merchant_id >", value, "merchantId");
            return (Criteria) this;
        }

        public Criteria andMerchantIdGreaterThanOrEqualTo(Long value) {
            addCriterion("merchant_id >=", value, "merchantId");
            return (Criteria) this;
        }

        public Criteria andMerchantIdLessThan(Long value) {
            addCriterion("merchant_id <", value, "merchantId");
            return (Criteria) this;
        }

        public Criteria andMerchantIdLessThanOrEqualTo(Long value) {
            addCriterion("merchant_id <=", value, "merchantId");
            return (Criteria) this;
        }

        public Criteria andMerchantIdIn(List<Long> values) {
            addCriterion("merchant_id in", values, "merchantId");
            return (Criteria) this;
        }

        public Criteria andMerchantIdNotIn(List<Long> values) {
            addCriterion("merchant_id not in", values, "merchantId");
            return (Criteria) this;
        }

        public Criteria andMerchantIdBetween(Long value1, Long value2) {
            addCriterion("merchant_id between", value1, value2, "merchantId");
            return (Criteria) this;
        }

        public Criteria andMerchantIdNotBetween(Long value1, Long value2) {
            addCriterion("merchant_id not between", value1, value2, "merchantId");
            return (Criteria) this;
        }

        public Criteria andMerchantStoreIdIsNull() {
            addCriterion("merchant_store_id is null");
            return (Criteria) this;
        }

        public Criteria andMerchantStoreIdIsNotNull() {
            addCriterion("merchant_store_id is not null");
            return (Criteria) this;
        }

        public Criteria andMerchantStoreIdEqualTo(Long value) {
            addCriterion("merchant_store_id =", value, "merchantStoreId");
            return (Criteria) this;
        }

        public Criteria andMerchantStoreIdNotEqualTo(Long value) {
            addCriterion("merchant_store_id <>", value, "merchantStoreId");
            return (Criteria) this;
        }

        public Criteria andMerchantStoreIdGreaterThan(Long value) {
            addCriterion("merchant_store_id >", value, "merchantStoreId");
            return (Criteria) this;
        }

        public Criteria andMerchantStoreIdGreaterThanOrEqualTo(Long value) {
            addCriterion("merchant_store_id >=", value, "merchantStoreId");
            return (Criteria) this;
        }

        public Criteria andMerchantStoreIdLessThan(Long value) {
            addCriterion("merchant_store_id <", value, "merchantStoreId");
            return (Criteria) this;
        }

        public Criteria andMerchantStoreIdLessThanOrEqualTo(Long value) {
            addCriterion("merchant_store_id <=", value, "merchantStoreId");
            return (Criteria) this;
        }

        public Criteria andMerchantStoreIdIn(List<Long> values) {
            addCriterion("merchant_store_id in", values, "merchantStoreId");
            return (Criteria) this;
        }

        public Criteria andMerchantStoreIdNotIn(List<Long> values) {
            addCriterion("merchant_store_id not in", values, "merchantStoreId");
            return (Criteria) this;
        }

        public Criteria andMerchantStoreIdBetween(Long value1, Long value2) {
            addCriterion("merchant_store_id between", value1, value2, "merchantStoreId");
            return (Criteria) this;
        }

        public Criteria andMerchantStoreIdNotBetween(Long value1, Long value2) {
            addCriterion("merchant_store_id not between", value1, value2, "merchantStoreId");
            return (Criteria) this;
        }

        public Criteria andAgentIdIsNull() {
            addCriterion("agent_id is null");
            return (Criteria) this;
        }

        public Criteria andAgentIdIsNotNull() {
            addCriterion("agent_id is not null");
            return (Criteria) this;
        }

        public Criteria andAgentIdEqualTo(Long value) {
            addCriterion("agent_id =", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdNotEqualTo(Long value) {
            addCriterion("agent_id <>", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdGreaterThan(Long value) {
            addCriterion("agent_id >", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdGreaterThanOrEqualTo(Long value) {
            addCriterion("agent_id >=", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdLessThan(Long value) {
            addCriterion("agent_id <", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdLessThanOrEqualTo(Long value) {
            addCriterion("agent_id <=", value, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdIn(List<Long> values) {
            addCriterion("agent_id in", values, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdNotIn(List<Long> values) {
            addCriterion("agent_id not in", values, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdBetween(Long value1, Long value2) {
            addCriterion("agent_id between", value1, value2, "agentId");
            return (Criteria) this;
        }

        public Criteria andAgentIdNotBetween(Long value1, Long value2) {
            addCriterion("agent_id not between", value1, value2, "agentId");
            return (Criteria) this;
        }

        public Criteria andPreOrderNoIsNull() {
            addCriterion("pre_order_no is null");
            return (Criteria) this;
        }

        public Criteria andPreOrderNoIsNotNull() {
            addCriterion("pre_order_no is not null");
            return (Criteria) this;
        }

        public Criteria andPreOrderNoEqualTo(String value) {
            addCriterion("pre_order_no =", value, "preOrderNo");
            return (Criteria) this;
        }

        public Criteria andPreOrderNoNotEqualTo(String value) {
            addCriterion("pre_order_no <>", value, "preOrderNo");
            return (Criteria) this;
        }

        public Criteria andPreOrderNoGreaterThan(String value) {
            addCriterion("pre_order_no >", value, "preOrderNo");
            return (Criteria) this;
        }

        public Criteria andPreOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("pre_order_no >=", value, "preOrderNo");
            return (Criteria) this;
        }

        public Criteria andPreOrderNoLessThan(String value) {
            addCriterion("pre_order_no <", value, "preOrderNo");
            return (Criteria) this;
        }

        public Criteria andPreOrderNoLessThanOrEqualTo(String value) {
            addCriterion("pre_order_no <=", value, "preOrderNo");
            return (Criteria) this;
        }

        public Criteria andPreOrderNoLike(String value) {
            addCriterion("pre_order_no like", value, "preOrderNo");
            return (Criteria) this;
        }

        public Criteria andPreOrderNoNotLike(String value) {
            addCriterion("pre_order_no not like", value, "preOrderNo");
            return (Criteria) this;
        }

        public Criteria andPreOrderNoIn(List<String> values) {
            addCriterion("pre_order_no in", values, "preOrderNo");
            return (Criteria) this;
        }

        public Criteria andPreOrderNoNotIn(List<String> values) {
            addCriterion("pre_order_no not in", values, "preOrderNo");
            return (Criteria) this;
        }

        public Criteria andPreOrderNoBetween(String value1, String value2) {
            addCriterion("pre_order_no between", value1, value2, "preOrderNo");
            return (Criteria) this;
        }

        public Criteria andPreOrderNoNotBetween(String value1, String value2) {
            addCriterion("pre_order_no not between", value1, value2, "preOrderNo");
            return (Criteria) this;
        }

        public Criteria andOrderIdIsNull() {
            addCriterion("order_id is null");
            return (Criteria) this;
        }

        public Criteria andOrderIdIsNotNull() {
            addCriterion("order_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrderIdEqualTo(Long value) {
            addCriterion("order_id =", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotEqualTo(Long value) {
            addCriterion("order_id <>", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdGreaterThan(Long value) {
            addCriterion("order_id >", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdGreaterThanOrEqualTo(Long value) {
            addCriterion("order_id >=", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdLessThan(Long value) {
            addCriterion("order_id <", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdLessThanOrEqualTo(Long value) {
            addCriterion("order_id <=", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdIn(List<Long> values) {
            addCriterion("order_id in", values, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotIn(List<Long> values) {
            addCriterion("order_id not in", values, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdBetween(Long value1, Long value2) {
            addCriterion("order_id between", value1, value2, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotBetween(Long value1, Long value2) {
            addCriterion("order_id not between", value1, value2, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNull() {
            addCriterion("order_no is null");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNotNull() {
            addCriterion("order_no is not null");
            return (Criteria) this;
        }

        public Criteria andOrderNoEqualTo(String value) {
            addCriterion("order_no =", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotEqualTo(String value) {
            addCriterion("order_no <>", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThan(String value) {
            addCriterion("order_no >", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("order_no >=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThan(String value) {
            addCriterion("order_no <", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThanOrEqualTo(String value) {
            addCriterion("order_no <=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLike(String value) {
            addCriterion("order_no like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotLike(String value) {
            addCriterion("order_no not like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoIn(List<String> values) {
            addCriterion("order_no in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotIn(List<String> values) {
            addCriterion("order_no not in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoBetween(String value1, String value2) {
            addCriterion("order_no between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotBetween(String value1, String value2) {
            addCriterion("order_no not between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andChildOrderIdIsNull() {
            addCriterion("child_order_id is null");
            return (Criteria) this;
        }

        public Criteria andChildOrderIdIsNotNull() {
            addCriterion("child_order_id is not null");
            return (Criteria) this;
        }

        public Criteria andChildOrderIdEqualTo(Long value) {
            addCriterion("child_order_id =", value, "childOrderId");
            return (Criteria) this;
        }

        public Criteria andChildOrderIdNotEqualTo(Long value) {
            addCriterion("child_order_id <>", value, "childOrderId");
            return (Criteria) this;
        }

        public Criteria andChildOrderIdGreaterThan(Long value) {
            addCriterion("child_order_id >", value, "childOrderId");
            return (Criteria) this;
        }

        public Criteria andChildOrderIdGreaterThanOrEqualTo(Long value) {
            addCriterion("child_order_id >=", value, "childOrderId");
            return (Criteria) this;
        }

        public Criteria andChildOrderIdLessThan(Long value) {
            addCriterion("child_order_id <", value, "childOrderId");
            return (Criteria) this;
        }

        public Criteria andChildOrderIdLessThanOrEqualTo(Long value) {
            addCriterion("child_order_id <=", value, "childOrderId");
            return (Criteria) this;
        }

        public Criteria andChildOrderIdIn(List<Long> values) {
            addCriterion("child_order_id in", values, "childOrderId");
            return (Criteria) this;
        }

        public Criteria andChildOrderIdNotIn(List<Long> values) {
            addCriterion("child_order_id not in", values, "childOrderId");
            return (Criteria) this;
        }

        public Criteria andChildOrderIdBetween(Long value1, Long value2) {
            addCriterion("child_order_id between", value1, value2, "childOrderId");
            return (Criteria) this;
        }

        public Criteria andChildOrderIdNotBetween(Long value1, Long value2) {
            addCriterion("child_order_id not between", value1, value2, "childOrderId");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceIsNull() {
            addCriterion("pay_real_price is null");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceIsNotNull() {
            addCriterion("pay_real_price is not null");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceEqualTo(BigDecimal value) {
            addCriterion("pay_real_price =", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceNotEqualTo(BigDecimal value) {
            addCriterion("pay_real_price <>", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceGreaterThan(BigDecimal value) {
            addCriterion("pay_real_price >", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("pay_real_price >=", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceLessThan(BigDecimal value) {
            addCriterion("pay_real_price <", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("pay_real_price <=", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceIn(List<BigDecimal> values) {
            addCriterion("pay_real_price in", values, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceNotIn(List<BigDecimal> values) {
            addCriterion("pay_real_price not in", values, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("pay_real_price between", value1, value2, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("pay_real_price not between", value1, value2, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIsNull() {
            addCriterion("goods_type is null");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIsNotNull() {
            addCriterion("goods_type is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeEqualTo(Integer value) {
            addCriterion("goods_type =", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNotEqualTo(Integer value) {
            addCriterion("goods_type <>", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeGreaterThan(Integer value) {
            addCriterion("goods_type >", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("goods_type >=", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeLessThan(Integer value) {
            addCriterion("goods_type <", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeLessThanOrEqualTo(Integer value) {
            addCriterion("goods_type <=", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIn(List<Integer> values) {
            addCriterion("goods_type in", values, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNotIn(List<Integer> values) {
            addCriterion("goods_type not in", values, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeBetween(Integer value1, Integer value2) {
            addCriterion("goods_type between", value1, value2, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("goods_type not between", value1, value2, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNull() {
            addCriterion("goods_id is null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNotNull() {
            addCriterion("goods_id is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdEqualTo(Long value) {
            addCriterion("goods_id =", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotEqualTo(Long value) {
            addCriterion("goods_id <>", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThan(Long value) {
            addCriterion("goods_id >", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThanOrEqualTo(Long value) {
            addCriterion("goods_id >=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThan(Long value) {
            addCriterion("goods_id <", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThanOrEqualTo(Long value) {
            addCriterion("goods_id <=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIn(List<Long> values) {
            addCriterion("goods_id in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotIn(List<Long> values) {
            addCriterion("goods_id not in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdBetween(Long value1, Long value2) {
            addCriterion("goods_id between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotBetween(Long value1, Long value2) {
            addCriterion("goods_id not between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsNameIsNull() {
            addCriterion("goods_name is null");
            return (Criteria) this;
        }

        public Criteria andGoodsNameIsNotNull() {
            addCriterion("goods_name is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsNameEqualTo(String value) {
            addCriterion("goods_name =", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotEqualTo(String value) {
            addCriterion("goods_name <>", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameGreaterThan(String value) {
            addCriterion("goods_name >", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameGreaterThanOrEqualTo(String value) {
            addCriterion("goods_name >=", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameLessThan(String value) {
            addCriterion("goods_name <", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameLessThanOrEqualTo(String value) {
            addCriterion("goods_name <=", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameLike(String value) {
            addCriterion("goods_name like", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotLike(String value) {
            addCriterion("goods_name not like", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameIn(List<String> values) {
            addCriterion("goods_name in", values, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotIn(List<String> values) {
            addCriterion("goods_name not in", values, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameBetween(String value1, String value2) {
            addCriterion("goods_name between", value1, value2, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotBetween(String value1, String value2) {
            addCriterion("goods_name not between", value1, value2, "goodsName");
            return (Criteria) this;
        }

        public Criteria andPreTimeIsNull() {
            addCriterion("pre_time is null");
            return (Criteria) this;
        }

        public Criteria andPreTimeIsNotNull() {
            addCriterion("pre_time is not null");
            return (Criteria) this;
        }

        public Criteria andPreTimeEqualTo(Date value) {
            addCriterion("pre_time =", value, "preTime");
            return (Criteria) this;
        }

        public Criteria andPreTimeNotEqualTo(Date value) {
            addCriterion("pre_time <>", value, "preTime");
            return (Criteria) this;
        }

        public Criteria andPreTimeGreaterThan(Date value) {
            addCriterion("pre_time >", value, "preTime");
            return (Criteria) this;
        }

        public Criteria andPreTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("pre_time >=", value, "preTime");
            return (Criteria) this;
        }

        public Criteria andPreTimeLessThan(Date value) {
            addCriterion("pre_time <", value, "preTime");
            return (Criteria) this;
        }

        public Criteria andPreTimeLessThanOrEqualTo(Date value) {
            addCriterion("pre_time <=", value, "preTime");
            return (Criteria) this;
        }

        public Criteria andPreTimeIn(List<Date> values) {
            addCriterion("pre_time in", values, "preTime");
            return (Criteria) this;
        }

        public Criteria andPreTimeNotIn(List<Date> values) {
            addCriterion("pre_time not in", values, "preTime");
            return (Criteria) this;
        }

        public Criteria andPreTimeBetween(Date value1, Date value2) {
            addCriterion("pre_time between", value1, value2, "preTime");
            return (Criteria) this;
        }

        public Criteria andPreTimeNotBetween(Date value1, Date value2) {
            addCriterion("pre_time not between", value1, value2, "preTime");
            return (Criteria) this;
        }

        public Criteria andPreUserIdIsNull() {
            addCriterion("pre_user_id is null");
            return (Criteria) this;
        }

        public Criteria andPreUserIdIsNotNull() {
            addCriterion("pre_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andPreUserIdEqualTo(Long value) {
            addCriterion("pre_user_id =", value, "preUserId");
            return (Criteria) this;
        }

        public Criteria andPreUserIdNotEqualTo(Long value) {
            addCriterion("pre_user_id <>", value, "preUserId");
            return (Criteria) this;
        }

        public Criteria andPreUserIdGreaterThan(Long value) {
            addCriterion("pre_user_id >", value, "preUserId");
            return (Criteria) this;
        }

        public Criteria andPreUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("pre_user_id >=", value, "preUserId");
            return (Criteria) this;
        }

        public Criteria andPreUserIdLessThan(Long value) {
            addCriterion("pre_user_id <", value, "preUserId");
            return (Criteria) this;
        }

        public Criteria andPreUserIdLessThanOrEqualTo(Long value) {
            addCriterion("pre_user_id <=", value, "preUserId");
            return (Criteria) this;
        }

        public Criteria andPreUserIdIn(List<Long> values) {
            addCriterion("pre_user_id in", values, "preUserId");
            return (Criteria) this;
        }

        public Criteria andPreUserIdNotIn(List<Long> values) {
            addCriterion("pre_user_id not in", values, "preUserId");
            return (Criteria) this;
        }

        public Criteria andPreUserIdBetween(Long value1, Long value2) {
            addCriterion("pre_user_id between", value1, value2, "preUserId");
            return (Criteria) this;
        }

        public Criteria andPreUserIdNotBetween(Long value1, Long value2) {
            addCriterion("pre_user_id not between", value1, value2, "preUserId");
            return (Criteria) this;
        }

        public Criteria andPreUserNameIsNull() {
            addCriterion("pre_user_name is null");
            return (Criteria) this;
        }

        public Criteria andPreUserNameIsNotNull() {
            addCriterion("pre_user_name is not null");
            return (Criteria) this;
        }

        public Criteria andPreUserNameEqualTo(String value) {
            addCriterion("pre_user_name =", value, "preUserName");
            return (Criteria) this;
        }

        public Criteria andPreUserNameNotEqualTo(String value) {
            addCriterion("pre_user_name <>", value, "preUserName");
            return (Criteria) this;
        }

        public Criteria andPreUserNameGreaterThan(String value) {
            addCriterion("pre_user_name >", value, "preUserName");
            return (Criteria) this;
        }

        public Criteria andPreUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("pre_user_name >=", value, "preUserName");
            return (Criteria) this;
        }

        public Criteria andPreUserNameLessThan(String value) {
            addCriterion("pre_user_name <", value, "preUserName");
            return (Criteria) this;
        }

        public Criteria andPreUserNameLessThanOrEqualTo(String value) {
            addCriterion("pre_user_name <=", value, "preUserName");
            return (Criteria) this;
        }

        public Criteria andPreUserNameLike(String value) {
            addCriterion("pre_user_name like", value, "preUserName");
            return (Criteria) this;
        }

        public Criteria andPreUserNameNotLike(String value) {
            addCriterion("pre_user_name not like", value, "preUserName");
            return (Criteria) this;
        }

        public Criteria andPreUserNameIn(List<String> values) {
            addCriterion("pre_user_name in", values, "preUserName");
            return (Criteria) this;
        }

        public Criteria andPreUserNameNotIn(List<String> values) {
            addCriterion("pre_user_name not in", values, "preUserName");
            return (Criteria) this;
        }

        public Criteria andPreUserNameBetween(String value1, String value2) {
            addCriterion("pre_user_name between", value1, value2, "preUserName");
            return (Criteria) this;
        }

        public Criteria andPreUserNameNotBetween(String value1, String value2) {
            addCriterion("pre_user_name not between", value1, value2, "preUserName");
            return (Criteria) this;
        }

        public Criteria andPreUserPhoneIsNull() {
            addCriterion("pre_user_phone is null");
            return (Criteria) this;
        }

        public Criteria andPreUserPhoneIsNotNull() {
            addCriterion("pre_user_phone is not null");
            return (Criteria) this;
        }

        public Criteria andPreUserPhoneEqualTo(String value) {
            addCriterion("pre_user_phone =", value, "preUserPhone");
            return (Criteria) this;
        }

        public Criteria andPreUserPhoneNotEqualTo(String value) {
            addCriterion("pre_user_phone <>", value, "preUserPhone");
            return (Criteria) this;
        }

        public Criteria andPreUserPhoneGreaterThan(String value) {
            addCriterion("pre_user_phone >", value, "preUserPhone");
            return (Criteria) this;
        }

        public Criteria andPreUserPhoneGreaterThanOrEqualTo(String value) {
            addCriterion("pre_user_phone >=", value, "preUserPhone");
            return (Criteria) this;
        }

        public Criteria andPreUserPhoneLessThan(String value) {
            addCriterion("pre_user_phone <", value, "preUserPhone");
            return (Criteria) this;
        }

        public Criteria andPreUserPhoneLessThanOrEqualTo(String value) {
            addCriterion("pre_user_phone <=", value, "preUserPhone");
            return (Criteria) this;
        }

        public Criteria andPreUserPhoneLike(String value) {
            addCriterion("pre_user_phone like", value, "preUserPhone");
            return (Criteria) this;
        }

        public Criteria andPreUserPhoneNotLike(String value) {
            addCriterion("pre_user_phone not like", value, "preUserPhone");
            return (Criteria) this;
        }

        public Criteria andPreUserPhoneIn(List<String> values) {
            addCriterion("pre_user_phone in", values, "preUserPhone");
            return (Criteria) this;
        }

        public Criteria andPreUserPhoneNotIn(List<String> values) {
            addCriterion("pre_user_phone not in", values, "preUserPhone");
            return (Criteria) this;
        }

        public Criteria andPreUserPhoneBetween(String value1, String value2) {
            addCriterion("pre_user_phone between", value1, value2, "preUserPhone");
            return (Criteria) this;
        }

        public Criteria andPreUserPhoneNotBetween(String value1, String value2) {
            addCriterion("pre_user_phone not between", value1, value2, "preUserPhone");
            return (Criteria) this;
        }

        public Criteria andPreUserRemarkIsNull() {
            addCriterion("pre_user_remark is null");
            return (Criteria) this;
        }

        public Criteria andPreUserRemarkIsNotNull() {
            addCriterion("pre_user_remark is not null");
            return (Criteria) this;
        }

        public Criteria andPreUserRemarkEqualTo(String value) {
            addCriterion("pre_user_remark =", value, "preUserRemark");
            return (Criteria) this;
        }

        public Criteria andPreUserRemarkNotEqualTo(String value) {
            addCriterion("pre_user_remark <>", value, "preUserRemark");
            return (Criteria) this;
        }

        public Criteria andPreUserRemarkGreaterThan(String value) {
            addCriterion("pre_user_remark >", value, "preUserRemark");
            return (Criteria) this;
        }

        public Criteria andPreUserRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("pre_user_remark >=", value, "preUserRemark");
            return (Criteria) this;
        }

        public Criteria andPreUserRemarkLessThan(String value) {
            addCriterion("pre_user_remark <", value, "preUserRemark");
            return (Criteria) this;
        }

        public Criteria andPreUserRemarkLessThanOrEqualTo(String value) {
            addCriterion("pre_user_remark <=", value, "preUserRemark");
            return (Criteria) this;
        }

        public Criteria andPreUserRemarkLike(String value) {
            addCriterion("pre_user_remark like", value, "preUserRemark");
            return (Criteria) this;
        }

        public Criteria andPreUserRemarkNotLike(String value) {
            addCriterion("pre_user_remark not like", value, "preUserRemark");
            return (Criteria) this;
        }

        public Criteria andPreUserRemarkIn(List<String> values) {
            addCriterion("pre_user_remark in", values, "preUserRemark");
            return (Criteria) this;
        }

        public Criteria andPreUserRemarkNotIn(List<String> values) {
            addCriterion("pre_user_remark not in", values, "preUserRemark");
            return (Criteria) this;
        }

        public Criteria andPreUserRemarkBetween(String value1, String value2) {
            addCriterion("pre_user_remark between", value1, value2, "preUserRemark");
            return (Criteria) this;
        }

        public Criteria andPreUserRemarkNotBetween(String value1, String value2) {
            addCriterion("pre_user_remark not between", value1, value2, "preUserRemark");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusFailDescIsNull() {
            addCriterion("status_fail_desc is null");
            return (Criteria) this;
        }

        public Criteria andStatusFailDescIsNotNull() {
            addCriterion("status_fail_desc is not null");
            return (Criteria) this;
        }

        public Criteria andStatusFailDescEqualTo(String value) {
            addCriterion("status_fail_desc =", value, "statusFailDesc");
            return (Criteria) this;
        }

        public Criteria andStatusFailDescNotEqualTo(String value) {
            addCriterion("status_fail_desc <>", value, "statusFailDesc");
            return (Criteria) this;
        }

        public Criteria andStatusFailDescGreaterThan(String value) {
            addCriterion("status_fail_desc >", value, "statusFailDesc");
            return (Criteria) this;
        }

        public Criteria andStatusFailDescGreaterThanOrEqualTo(String value) {
            addCriterion("status_fail_desc >=", value, "statusFailDesc");
            return (Criteria) this;
        }

        public Criteria andStatusFailDescLessThan(String value) {
            addCriterion("status_fail_desc <", value, "statusFailDesc");
            return (Criteria) this;
        }

        public Criteria andStatusFailDescLessThanOrEqualTo(String value) {
            addCriterion("status_fail_desc <=", value, "statusFailDesc");
            return (Criteria) this;
        }

        public Criteria andStatusFailDescLike(String value) {
            addCriterion("status_fail_desc like", value, "statusFailDesc");
            return (Criteria) this;
        }

        public Criteria andStatusFailDescNotLike(String value) {
            addCriterion("status_fail_desc not like", value, "statusFailDesc");
            return (Criteria) this;
        }

        public Criteria andStatusFailDescIn(List<String> values) {
            addCriterion("status_fail_desc in", values, "statusFailDesc");
            return (Criteria) this;
        }

        public Criteria andStatusFailDescNotIn(List<String> values) {
            addCriterion("status_fail_desc not in", values, "statusFailDesc");
            return (Criteria) this;
        }

        public Criteria andStatusFailDescBetween(String value1, String value2) {
            addCriterion("status_fail_desc between", value1, value2, "statusFailDesc");
            return (Criteria) this;
        }

        public Criteria andStatusFailDescNotBetween(String value1, String value2) {
            addCriterion("status_fail_desc not between", value1, value2, "statusFailDesc");
            return (Criteria) this;
        }

        public Criteria andStatusCancelDescIsNull() {
            addCriterion("status_cancel_desc is null");
            return (Criteria) this;
        }

        public Criteria andStatusCancelDescIsNotNull() {
            addCriterion("status_cancel_desc is not null");
            return (Criteria) this;
        }

        public Criteria andStatusCancelDescEqualTo(String value) {
            addCriterion("status_cancel_desc =", value, "statusCancelDesc");
            return (Criteria) this;
        }

        public Criteria andStatusCancelDescNotEqualTo(String value) {
            addCriterion("status_cancel_desc <>", value, "statusCancelDesc");
            return (Criteria) this;
        }

        public Criteria andStatusCancelDescGreaterThan(String value) {
            addCriterion("status_cancel_desc >", value, "statusCancelDesc");
            return (Criteria) this;
        }

        public Criteria andStatusCancelDescGreaterThanOrEqualTo(String value) {
            addCriterion("status_cancel_desc >=", value, "statusCancelDesc");
            return (Criteria) this;
        }

        public Criteria andStatusCancelDescLessThan(String value) {
            addCriterion("status_cancel_desc <", value, "statusCancelDesc");
            return (Criteria) this;
        }

        public Criteria andStatusCancelDescLessThanOrEqualTo(String value) {
            addCriterion("status_cancel_desc <=", value, "statusCancelDesc");
            return (Criteria) this;
        }

        public Criteria andStatusCancelDescLike(String value) {
            addCriterion("status_cancel_desc like", value, "statusCancelDesc");
            return (Criteria) this;
        }

        public Criteria andStatusCancelDescNotLike(String value) {
            addCriterion("status_cancel_desc not like", value, "statusCancelDesc");
            return (Criteria) this;
        }

        public Criteria andStatusCancelDescIn(List<String> values) {
            addCriterion("status_cancel_desc in", values, "statusCancelDesc");
            return (Criteria) this;
        }

        public Criteria andStatusCancelDescNotIn(List<String> values) {
            addCriterion("status_cancel_desc not in", values, "statusCancelDesc");
            return (Criteria) this;
        }

        public Criteria andStatusCancelDescBetween(String value1, String value2) {
            addCriterion("status_cancel_desc between", value1, value2, "statusCancelDesc");
            return (Criteria) this;
        }

        public Criteria andStatusCancelDescNotBetween(String value1, String value2) {
            addCriterion("status_cancel_desc not between", value1, value2, "statusCancelDesc");
            return (Criteria) this;
        }

        public Criteria andReachTimeIsNull() {
            addCriterion("reach_time is null");
            return (Criteria) this;
        }

        public Criteria andReachTimeIsNotNull() {
            addCriterion("reach_time is not null");
            return (Criteria) this;
        }

        public Criteria andReachTimeEqualTo(Date value) {
            addCriterion("reach_time =", value, "reachTime");
            return (Criteria) this;
        }

        public Criteria andReachTimeNotEqualTo(Date value) {
            addCriterion("reach_time <>", value, "reachTime");
            return (Criteria) this;
        }

        public Criteria andReachTimeGreaterThan(Date value) {
            addCriterion("reach_time >", value, "reachTime");
            return (Criteria) this;
        }

        public Criteria andReachTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("reach_time >=", value, "reachTime");
            return (Criteria) this;
        }

        public Criteria andReachTimeLessThan(Date value) {
            addCriterion("reach_time <", value, "reachTime");
            return (Criteria) this;
        }

        public Criteria andReachTimeLessThanOrEqualTo(Date value) {
            addCriterion("reach_time <=", value, "reachTime");
            return (Criteria) this;
        }

        public Criteria andReachTimeIn(List<Date> values) {
            addCriterion("reach_time in", values, "reachTime");
            return (Criteria) this;
        }

        public Criteria andReachTimeNotIn(List<Date> values) {
            addCriterion("reach_time not in", values, "reachTime");
            return (Criteria) this;
        }

        public Criteria andReachTimeBetween(Date value1, Date value2) {
            addCriterion("reach_time between", value1, value2, "reachTime");
            return (Criteria) this;
        }

        public Criteria andReachTimeNotBetween(Date value1, Date value2) {
            addCriterion("reach_time not between", value1, value2, "reachTime");
            return (Criteria) this;
        }

        public Criteria andReachAddressIsNull() {
            addCriterion("reach_address is null");
            return (Criteria) this;
        }

        public Criteria andReachAddressIsNotNull() {
            addCriterion("reach_address is not null");
            return (Criteria) this;
        }

        public Criteria andReachAddressEqualTo(String value) {
            addCriterion("reach_address =", value, "reachAddress");
            return (Criteria) this;
        }

        public Criteria andReachAddressNotEqualTo(String value) {
            addCriterion("reach_address <>", value, "reachAddress");
            return (Criteria) this;
        }

        public Criteria andReachAddressGreaterThan(String value) {
            addCriterion("reach_address >", value, "reachAddress");
            return (Criteria) this;
        }

        public Criteria andReachAddressGreaterThanOrEqualTo(String value) {
            addCriterion("reach_address >=", value, "reachAddress");
            return (Criteria) this;
        }

        public Criteria andReachAddressLessThan(String value) {
            addCriterion("reach_address <", value, "reachAddress");
            return (Criteria) this;
        }

        public Criteria andReachAddressLessThanOrEqualTo(String value) {
            addCriterion("reach_address <=", value, "reachAddress");
            return (Criteria) this;
        }

        public Criteria andReachAddressLike(String value) {
            addCriterion("reach_address like", value, "reachAddress");
            return (Criteria) this;
        }

        public Criteria andReachAddressNotLike(String value) {
            addCriterion("reach_address not like", value, "reachAddress");
            return (Criteria) this;
        }

        public Criteria andReachAddressIn(List<String> values) {
            addCriterion("reach_address in", values, "reachAddress");
            return (Criteria) this;
        }

        public Criteria andReachAddressNotIn(List<String> values) {
            addCriterion("reach_address not in", values, "reachAddress");
            return (Criteria) this;
        }

        public Criteria andReachAddressBetween(String value1, String value2) {
            addCriterion("reach_address between", value1, value2, "reachAddress");
            return (Criteria) this;
        }

        public Criteria andReachAddressNotBetween(String value1, String value2) {
            addCriterion("reach_address not between", value1, value2, "reachAddress");
            return (Criteria) this;
        }

        public Criteria andOpUserIdIsNull() {
            addCriterion("op_user_id is null");
            return (Criteria) this;
        }

        public Criteria andOpUserIdIsNotNull() {
            addCriterion("op_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andOpUserIdEqualTo(Long value) {
            addCriterion("op_user_id =", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdNotEqualTo(Long value) {
            addCriterion("op_user_id <>", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdGreaterThan(Long value) {
            addCriterion("op_user_id >", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("op_user_id >=", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdLessThan(Long value) {
            addCriterion("op_user_id <", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdLessThanOrEqualTo(Long value) {
            addCriterion("op_user_id <=", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdIn(List<Long> values) {
            addCriterion("op_user_id in", values, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdNotIn(List<Long> values) {
            addCriterion("op_user_id not in", values, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdBetween(Long value1, Long value2) {
            addCriterion("op_user_id between", value1, value2, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdNotBetween(Long value1, Long value2) {
            addCriterion("op_user_id not between", value1, value2, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserNameIsNull() {
            addCriterion("op_user_name is null");
            return (Criteria) this;
        }

        public Criteria andOpUserNameIsNotNull() {
            addCriterion("op_user_name is not null");
            return (Criteria) this;
        }

        public Criteria andOpUserNameEqualTo(String value) {
            addCriterion("op_user_name =", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameNotEqualTo(String value) {
            addCriterion("op_user_name <>", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameGreaterThan(String value) {
            addCriterion("op_user_name >", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("op_user_name >=", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameLessThan(String value) {
            addCriterion("op_user_name <", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameLessThanOrEqualTo(String value) {
            addCriterion("op_user_name <=", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameLike(String value) {
            addCriterion("op_user_name like", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameNotLike(String value) {
            addCriterion("op_user_name not like", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameIn(List<String> values) {
            addCriterion("op_user_name in", values, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameNotIn(List<String> values) {
            addCriterion("op_user_name not in", values, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameBetween(String value1, String value2) {
            addCriterion("op_user_name between", value1, value2, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameNotBetween(String value1, String value2) {
            addCriterion("op_user_name not between", value1, value2, "opUserName");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt4IsNull() {
            addCriterion("ext_4 is null");
            return (Criteria) this;
        }

        public Criteria andExt4IsNotNull() {
            addCriterion("ext_4 is not null");
            return (Criteria) this;
        }

        public Criteria andExt4EqualTo(String value) {
            addCriterion("ext_4 =", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4NotEqualTo(String value) {
            addCriterion("ext_4 <>", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4GreaterThan(String value) {
            addCriterion("ext_4 >", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4GreaterThanOrEqualTo(String value) {
            addCriterion("ext_4 >=", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4LessThan(String value) {
            addCriterion("ext_4 <", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4LessThanOrEqualTo(String value) {
            addCriterion("ext_4 <=", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4Like(String value) {
            addCriterion("ext_4 like", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4NotLike(String value) {
            addCriterion("ext_4 not like", value, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4In(List<String> values) {
            addCriterion("ext_4 in", values, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4NotIn(List<String> values) {
            addCriterion("ext_4 not in", values, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4Between(String value1, String value2) {
            addCriterion("ext_4 between", value1, value2, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt4NotBetween(String value1, String value2) {
            addCriterion("ext_4 not between", value1, value2, "ext4");
            return (Criteria) this;
        }

        public Criteria andExt5IsNull() {
            addCriterion("ext_5 is null");
            return (Criteria) this;
        }

        public Criteria andExt5IsNotNull() {
            addCriterion("ext_5 is not null");
            return (Criteria) this;
        }

        public Criteria andExt5EqualTo(String value) {
            addCriterion("ext_5 =", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5NotEqualTo(String value) {
            addCriterion("ext_5 <>", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5GreaterThan(String value) {
            addCriterion("ext_5 >", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5GreaterThanOrEqualTo(String value) {
            addCriterion("ext_5 >=", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5LessThan(String value) {
            addCriterion("ext_5 <", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5LessThanOrEqualTo(String value) {
            addCriterion("ext_5 <=", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5Like(String value) {
            addCriterion("ext_5 like", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5NotLike(String value) {
            addCriterion("ext_5 not like", value, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5In(List<String> values) {
            addCriterion("ext_5 in", values, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5NotIn(List<String> values) {
            addCriterion("ext_5 not in", values, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5Between(String value1, String value2) {
            addCriterion("ext_5 between", value1, value2, "ext5");
            return (Criteria) this;
        }

        public Criteria andExt5NotBetween(String value1, String value2) {
            addCriterion("ext_5 not between", value1, value2, "ext5");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}